// Header File
// Created 16.01.04; 13:46:32

#define MAX_PIXEL_MEM 100
struct pixel_type pixel[MAX_PIXEL_MEM];

struct pixel_type
{
	unsigned char x, y, xo, yo, xoo, yoo;
	char xs, ys, col;
};

//****************************************************************************

int xe, ye, ze, max_pixel=0;
unsigned char ch2;

struct pixel_type pixel[MAX_PIXEL_MEM];

//****************************************************************************

void get_screen_to_pixel(void)
{
	i=0;
	for (y=0; y<MAX_Y && !kbhit(); y += 1)
		for (x=y%3; x<MAX_X-2; x += 3)
		{
			GraySetAMSPlane (LIGHT_PLANE); ch=GetPix(x, y);
			GraySetAMSPlane (DARK_PLANE); ch2=GetPix(x, y);

			if (!(ch==0 && ch2==0) && i<MAX_PIXEL_MEM)
			{
				if (ch==1 && ch2==0) pixel[i].col=1;
				if (ch==0 && ch2==1) pixel[i].col=2;
				if (ch==1 && ch2==1) pixel[i].col=3;
				pixel[i].xoo = pixel[i].xo = pixel[i].x = x;
				pixel[i].yoo = pixel[i].yo = pixel[i].y = y;
				
				max_pixel=i;
				i++;
			}else
			if (i>=MAX_PIXEL_MEM) atexit;
		}
}

//****************************************************************************

void print_pixel(int i, char border)
{
  if (pixel[i].col>0)
  {
		GraySetAMSPlane (LIGHT_PLANE); DrawLine(pixel[i].xo, pixel[i].yo, pixel[i].xoo, pixel[i].yoo, A_REVERSE);
		GraySetAMSPlane (DARK_PLANE); DrawLine(pixel[i].xo, pixel[i].yo, pixel[i].xoo, pixel[i].yoo, A_REVERSE);
	  if ((pixel[i].x>=0 && pixel[i].x<MAX_X) && (pixel[i].y>=0 && pixel[i].y<MAX_Y))
	  {
			switch (pixel[i].col)
			{
				case 1:
					GraySetAMSPlane (LIGHT_PLANE); DrawLine(pixel[i].x, pixel[i].y, pixel[i].xo, pixel[i].yo, A_NORMAL);
					GraySetAMSPlane (DARK_PLANE); DrawLine(pixel[i].x, pixel[i].y, pixel[i].xo, pixel[i].yo, A_REVERSE);
					break;
				case 2:
					GraySetAMSPlane (LIGHT_PLANE); DrawLine(pixel[i].x, pixel[i].y, pixel[i].xo, pixel[i].yo, A_REVERSE);
					GraySetAMSPlane (DARK_PLANE); DrawLine(pixel[i].x, pixel[i].y, pixel[i].xo, pixel[i].yo, A_NORMAL);
					break;
				case 3:
					GraySetAMSPlane (LIGHT_PLANE); DrawLine(pixel[i].x, pixel[i].y, pixel[i].xo, pixel[i].yo, A_NORMAL);
					GraySetAMSPlane (DARK_PLANE); DrawLine(pixel[i].x, pixel[i].y, pixel[i].xo, pixel[i].yo, A_NORMAL);
					break;
			}
			pixel[i].xoo=pixel[i].xo;
			pixel[i].yoo=pixel[i].yo;
			pixel[i].xo=pixel[i].x;
			pixel[i].yo=pixel[i].y;
		}
		else
		if (border) { pixel[i].col=0; }
	}
}

//****************************************************************************

void title(void)
{
			get_screen_to_pixel();
			for (i=0; i<max_pixel; i++)
			{
				pixel[i].xs=random(2);
				pixel[i].ys=0;
			}
			l=0;
			while (l < 40 && !kbhit())
			{
				l++;
				for (i=0; i<max_pixel; i++)
				{
					pixel[i].x+=pixel[i].xs;
					pixel[i].y+=pixel[i].ys;
					print_pixel(i, 1);

					if (!random(3)) /*if (l<5)*/	pixel[i].xs+=random(2);	
					if (!random(10)) /*if (l<5)*/	pixel[i].ys+=random(3)-1;	
					if (!random(10)) pixel[i].ys+=1;
				}
			}
}	
